/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    snmpInitAgent.h
 *
 * Date:        Februari 1994
 *
 * Purpose:     partyMIB-related definitions.
 *
 * Author( s): 	Michel van Ooijen & Edward Veluwenkamp
 *
 * -----------------------------------------------------------------------
 */

#ifndef	SNMPINITAGENT_H
#define	SNMPINITAGENT_H

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/time.h>

/* 
 *	Type and macro definitions.
 */
#define MAXRECSTR 100 
#define ARLEN 100 
#define MAXSTRLEN 40
#define BUFSIZE 512
#define MAXAPPL 100
#define FILELEN 100
#define FILENAMELEN 100
#define HOSTNAMELEN 100
#define INTARRLEN 32
#define lengthEntry 100

typedef int	INTEGER;	/* local integer representation, int: 32 bits */
extern int errno;

/*
 *	The SNMPV2 party database group related structures
 */
typedef struct {
        char 		FriendbyName[MAXRECSTR];
        char  		partyIdentity[MAXRECSTR]; 	
	INTEGER		partyIndex;		/* position in the partyTable */
	char		partyTDomain[MAXRECSTR];
        char            IPaddress[MAXRECSTR];
	char		partyTAddress[MAXRECSTR];
	char		partyMaxMessageSize[MAXRECSTR];
	char		partyLocal; 			/* own or remote party */
	char		partyAuthProtocol[MAXRECSTR];
	char		partyAuthClock[MAXRECSTR];
	char		partyAuthPrivate[MAXRECSTR];
	char		partyAuthPublic[MAXRECSTR];
	char 	 	partyAuthLifeTime[MAXRECSTR];
	char		partyPrivProtocol[MAXRECSTR];
	char		partyPrivPrivate[MAXRECSTR];
	char		partyPrivPublic[MAXRECSTR];
} PartyEntry;

typedef struct {
        char 		contextName[MAXRECSTR];
        char		contextIdentity[MAXRECSTR];
        char            IPaddress[MAXRECSTR];
	INTEGER		contextIndex;	/* position in the contextTable */
	char 		contextLocal;	/* objects on this or remote system */
	INTEGER		contextViewIndex; /* could be a union structure */
	char		contextLocalEntity[MAXRECSTR];
	char		contextLocalTime[MAXRECSTR];
	char		contextProxyDstParty[MAXRECSTR];
	char		contextProxySrcParty[MAXRECSTR];
	char		contextProxyContext[MAXRECSTR];
} ContextEntry;

typedef struct {
	char		aclTarget[MAXRECSTR];
	char		aclSubject[MAXRECSTR];
	char		aclResources[MAXRECSTR];
	char		aclPrivileges[MAXRECSTR];
} AclEntry;

typedef struct {
	int		viewIndex;
	char   		viewSubtree[MAXRECSTR];
	char 		viewMask[MAXRECSTR];
	char		viewType[MAXRECSTR];
} ViewEntry;


#ifdef MAIN

char PartyIdentityStand[] = ".1.3.6.1.6.3.3.1.3.";
char ContextIdentityStand[] = ".1.3.6.1.6.3.3.1.4.";
char Partyfile[] = "_party.conf";
char Viewfile[] = "_view.conf";
char Aclfile[] =  "_acl.conf";
char Contextfile[] = "_context.conf";
char ViewIniFile[] = "view.ini";
char AclIniFile[] =  "acl.ini";
char ContextIniFile[] = "context.ini";
char PartyIniFile[] = "party.ini";

#else

extern char PartyIdentityStand[];
extern char ContextIdentityStand[];
extern char Partyfile[];
extern char Viewfile[];
extern char Aclfile[];
extern char Contextfile[];
extern char ViewIniFile[];
extern char AclIniFile[];
extern char ContextIniFile[];
extern char PartyIniFile[];

#endif

extern int UINcontextuser( int kindmess, char *cname, char *hostnameA );
extern void UINintro( char *hostnameM, char *ipaddressM, char *hostnameA,
	    	      char *ipaddressA, char *maxmessage, char *taddressM,
		      char *taddressA );
extern int UINpartyuser( int kindmess, char *mname, char *hostnameA,
			char *aname );
extern void SINgetrandomkey( char *randomkey );

#endif	/* SNMPINITAGENT_H */


