/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    spmMD5.h
 *
 * Date:        May 1994
 *
 * Purpose:     MD5-function based on functions of RSA Data Security, Inc.
 *
 * Author(s):   R. Oude Vrielink 
 *
 * -----------------------------------------------------------------------
*/

#ifndef SPMMD5_H
#define SPMMD5_H

#include <snmpTypes.h>

#define	DIGESTSIZE	16	/* the size of authdigest used in send and receive */

EXTERN STATUS MD5();
	
typedef unsigned char *POINTER;
typedef unsigned short int UINT2;
typedef unsigned long int UINT4;

#ifndef PROTOTYPES
#define PROTOTYPES 0
#endif

#if PROTOTYPES
#define PROTO_LIST(list) list
#else
#define PROTO_LIST(list) ()
#endif


typedef struct {
  UINT4 state[4];                                   /* state (ABCD) */
  UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                         /* input buffer */
} MD5_CTX;

void MD5Init PROTO((MD5_CTX *));
void MD5Update PROTO((MD5_CTX *, unsigned char *, unsigned int));
void MD5Final PROTO((unsigned char [16], MD5_CTX *));

#endif 	/* !SPMMD5_H */
