/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    SpmReceive.h
 *
 * Date:        May 1994
 *
 * Purpose:	include file for SpmReceive.c	
 *
 * Author(s):	Vincent Berkhout, Frederic P. H. van Hengstum,
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMRECEIVE_H
#define SPMRECEIVE_H

#include <sim.h>
#include <spmTIM.h>
#include <spmAWM.h>
#include <spmMIB_INT.h>
#include <spmSnmpMIB.h>
#include <spmList.h>
#include <spmBer1.h>
#include <spmBer2.h>
#include <spmMD5.h>
#include <spmDES.h>

/*
 *	CONSTANTS.
 */
#ifndef	UNAUTH
#define UNAUTH	0	/* message is not or should not be authenticated */
#endif

#ifndef AUTH
#define AUTH	1	/* message is or should be authenticated */ 
#endif

#define	AGENTMASK	0x2b	/* 0010 1011 */
#define MANAGERMASK	0xc4	/* 1100 0100 */

#define ASN1_seq	0x00	/* No idea ??? */

static int SNMP_DEBUG_RECEIVE = 20;

/*
 *	TYPE DEFINITIONS.
 */
/*
 *	TABLE DECLARATION
 */

typedef	struct	CacheOid {
	UAsnInt	index ;
	AsnOid	*oid;
} CacheOid ; 

/*
 *	EXPORT FUNCTIONS
 * -------------------------------------------------------------------
 * Function:    SpmInitReceive
 * Arguments:   none 
 * Returns:     STATUS  which is OK on succes
 * Purpose:     assign the value of some global "constants"
 * -------------------------------------------------------------------
 */
 /*
EXTERN	STATUS SpmInitReceive PROTO(()) ;
*/

/*
 * -------------------------------------------------------------------
 * Function:	SpmReceive		
 * Arguments:	none
 * Returns:	STATUS	which is OK on succes
 * Purpose:	The message that is received from the transportlayer
 *		can now be processed, according to RFC1445 (and 1446) 
 * Remarks:	none
 * -------------------------------------------------------------------
 */
EXTERN STATUS SpmReceive PROTO(()) ;

#endif /* ! SPMRECEIVE_H */

EXTERN char * getenv() ;
EXTERN STATUS MibResetAclEntry PROTO(()) ;
EXTERN STATUS MibGetAclEntry PROTO(()) ;
EXTERN STATUS MibGetPartyLocal PROTO(()) ;
EXTERN STATUS MibInsertLocalEntry PROTO(()) ;
EXTERN STATUS MibGetPartyTDomain PROTO(()) ;
EXTERN STATUS DomainConvert PROTO(()) ;
EXTERN STATUS MibGetPartyTAddress PROTO(()) ;
EXTERN STATUS SpmUnwrap PROTO(()) ;

INTERN STATUS UnwrapDecryptPrivData PROTO(()) ;
INTERN STATUS AuthenticateSnmpAuthMsg PROTO(()) ;


/* --------------------- end of file SpmReceive.h --------------------- */
