/* -----------------------------------------------------------------------
 * $Id: 
 * Project:	ut-snmp project
 * Filename:	snmpInitManSys.c
 * Date:	April 1994
 * Purpose:
 * Author(s):	Edward Veluwenkamp & Michel van Ooijen
 * Remarks:
 * -----------------------------------------------------------------------
 */

#include <snmpInitManSys.h>
#include <snmpInitManager.h>


/* -----------------------------------------------------------------------
 *  Function : MISgetipaddress
 *  Arguments: IPAddr, string which contains IPADDRESS in base 256 notation (d.d.d.d) (IN/OUT)
 *  Purpose  : Gets IPAddress of the system
 *  Remarks  :
 * -----------------------------------------------------------------------
 */
void MISgetipaddress(ipaddr)
   char *ipaddr; 
{
	struct 	hostent	*he ;
/*	struct	in_addr	inaddr ; */
        char            name[MAXHOSTNAMELEN];
    
        gethostname(name,MAXHOSTNAMELEN);
	he = gethostbyname(name);                      /* get IP-address from hostname */
       	if (he != (struct hostent *)0) 
             strcpy( ipaddr, inet_ntoa( *((struct in_addr *) (he->h_addr_list))));
}




/* -----------------------------------------------------------------------
 *  Function  : MISgetipadrname
 *  Arguments : IPAddr, string which contains IPADDRESS in base 256 notation (d.d.d.d) (IN/OUT)
 *            : name, string (IN/OUT)
 *  Purpose   : Gets IPAddress of the system with hostname name
 *  Remarks   :
 * -----------------------------------------------------------------------
 */
int MISgetipadrname(ipaddr,name)
   char *ipaddr,*name; 
{
	struct 	hostent	*he ;
/*	struct	in_addr	inaddr ; */

       	he = gethostbyname(name);                  /* get IP-address from hostname */
        if (he != NULL) 
      	  {if (he != (struct hostent *)0) 
             strcpy( ipaddr, inet_ntoa( *((struct in_addr *) (he->h_addr_list))) );
            return(0);
          }
        else return(-1);
}




/* -----------------------------------------------------------------------
 *  Function : MISgetipaddresshostname
 *  Arguments: kindmess, counter (IN)
 *           : ipaddress, pointer to ipaddress (IN/OUT)
 *           : name, pointer to array hostname (IN/OUT)
 *  Purpose  : Gets IPaddress of the system with hostname = name  
 *  Remarks  : returns the IPaddress 
 * -----------------------------------------------------------------------
 */
void MISgetipaddresshostname(kindmess,ipaddress,name)
 int  kindmess;
 char *ipaddress,*name;
{
  char bool1,ch;
  int  i;
 
  do
   {
    switch (kindmess)
      {
        case 0 : gethostname( name, 50 );
                 fprintf( stdout, "\t1) Hostname of management system [%s]: ",
			  name );
		 break;
        case 1 : gethostname( name, 50 );
		 fprintf( stdout, "\t2) Hostname of agent system [%s]: ",
			  name );
		 break;
      }
    fflush(stdin);
    i = 0;
    ch = name[0];
    do
     {
      name[i++] = getchar();       /* replaces scanf routine, because '\n' as only character not accepted by scanf */
     }
    while (name[i-1] != '\n');
    if (name[0] == '\n')
       {
	name[0] = ch;
	switch(kindmess)
	 {
	   case 0: strcpy (ipaddress,"0.0.0.0");
		   break;
	   case 1: MISgetipaddress (ipaddress);
		   break;
         } 
        bool1 = '0';
       }
    else
      { 
       name[i-1] = '\0';
       if (MISgetipadrname(ipaddress,name) == 0)
             bool1 = '0';
       else
         {
          fprintf( stdout, "\t\tERROR: invalid hostname/internet address.\n" );
          bool1 = '1';      
         }
       } 
    }
  while (bool1 != '0');
}



/* -----------------------------------------------------------------------------
 *  Function : MISgetint
 *  Arguments: none
 *  Purpose  : reads an integer from console
 *  Remarks  : returns an integer
 * -----------------------------------------------------------------------------
 */
int MISgetint()
{
#define INTARRLEN 32
	int intAr[INTARRLEN];
	char charAr[INTARRLEN];
	int i=0;

	do {
		intAr[i] = getchar();
		i++;
	} while( (intAr[i-1] != '\n') && (i < INTARRLEN) );
	intAr[i-1] = '\0';
	i = 0;
	while (intAr[i] != '\0') {
		if (isdigit(intAr[i]) == 0)
			return( -1 );
		else charAr[i] = (char) intAr[i];
		i++;
	}
	charAr[i] = '\0';
	return( atoi( (const char *) charAr ) );
   }


/* -----------------------------------------------------------------------
 *  Function : MIScreatehostname
 *  Arguments: kindmess, counter (IN)
 *           : hostname, pointer to array hostname (IN/OUT)
 *           : num, pointer to array (IN/OUT)
 *  Purpose  : create a hostname to identify the application and used system 
 *  Remarks  :   
 * -----------------------------------------------------------------------
 */
void MIScreatehostname(kindmess,hostname,num)
 char *hostname;
 int   kindmess,*num;
 {
  int  check=0,four,i;
  char chnum[ARLEN];
  
  switch(kindmess)
   {
    case 0:printf("\nThe following Manager(s) exists\n\n");break;
    case 1:printf("\nThe following Agent(s) exist\n\n");break;        
   } 
  while (check < MAXAPPL)
   {
    four = 0;
    for(i=0;i<lengthEntry;i++)
     {
       if (num[i] == check) four++;
     }
    if (four == 4)
       switch(kindmess)
         {
           case 0:printf("Manager %s%d\n",hostname,check);break;
           case 1:printf("Agent %s%d\n",hostname,check);break;        
         }
    check++;
   }
   printf("\nGive number to identify application, default[0] :");
   sprintf(chnum,"%d",MISgetint());
   strcat(hostname,chnum);
  }
 

/* -----------------------------------------------------------------------
 *  Function : MISipaddresshostname
 *  Arguments: kindmess, counter (IN)
 *           : ipaddress, pointer to array ipaddress (IN/OUT)
 *           : hostname, pointer to array hostname (IN/OUT)
 *  Arguments: kindmess,ipaddress,name  
 *  Purpose  : to find ipaddress and hostname to identify an appliction uniquely 
 *  Remarks  : returns ipaddress and hostname
 * -----------------------------------------------------------------------
 */
void MISipaddresshostname(kindmess,ipaddress,hostname)
char *ipaddress,*hostname;
int kindmess;
 {
/*char  *cmd = "/usr/bin/ls ", buf[BUFSIZE], numberarr[ARLEN];
  int    num[lengthEntry];
  FILE  *ptr;
  int    i,j,k,number;
  char   filename[ARLEN];
*/   
  MISgetipaddresshostname(kindmess,ipaddress,hostname);
/*  if (kindmess == 0) strcat (hostname,"_M",2);
  if (kindmess == 1) strcat (hostname,"_A",2);
  for (k=0;k<lengthEntry;k++) 
    {
     num[k]= -1;
    }
  k=0;
  strcpy(filename,cmd);
  strcat(filename,CMU_PATH);
  if ((ptr = popen(filename, "r")) != NULL)
       while (fgets(buf, BUFSIZE, ptr) != NULL)
         {
          if (strncmp(hostname,buf,strlen(hostname)) == 0) 
             {
               i=0;
               while ((buf[i] != '\0') && (buf[i] != '_')) i++;
               i=i+2; 
               j=0;
               while ((buf[i] != '\0') && (buf[i] != '_'))
                  {
                   numberarr[j] = buf[i]; i++; j++;
                  }
               numberarr[j] = '\0';
               num[k++] = atoi(numberarr);             
             }
         }
        MIScreatehostname(kindmess,hostname,num);  
*/        
 }
 

