/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    snmpv2_per.c
 *
 * Date:        May 1994.
 *
 * Purpose:     Interface to PER modules.
 *
 * Author(s):   Rene Oude Vrielink
 *
 * -----------------------------------------------------------------------
 */
/*
 *    snmpv2_per.c
 *
 *    "SNMPv2-MESS" ASN.1 module encode/decode/print/free C src.
 *
 *    This file was generated by snacc on Mon Feb 28 13:08:38 1994
 *
 *    UBC snacc written by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */


#include <snmpTypes.h>
#include <snacc/asn_config.h>
#include <perv2/per_buf.h>
#include <perv2/per_bits.h>
#include <perv2/per_int.h>
#include <perv2/per_len.h>
#include <perv2/per_octs.h>
#include <perv2/per_oid.h>
#include <perv2/snmpv2_per.h>

/*
 * 	these oids are moved to snmpConst.h and assigned
 * 	in spmMisc.c
 *
AsnInt max_bindings = 2147483647;
AsnOid internet = { 3, "\53\6\1" };
AsnOid directory = { 4, "\53\6\1\1" };
AsnOid mgmt = { 4, "\53\6\1\2" };
AsnOid experimental = { 4, "\53\6\1\3" };
AsnOid private = { 4, "\53\6\1\4" };
AsnOid enterprises = { 5, "\53\6\1\4\1" };
AsnOid security = { 4, "\53\6\1\5" };
AsnOid snmpV2 = { 4, "\53\6\1\6" };
AsnOid snmpDomains = { 5, "\53\6\1\6\1" };
AsnOid snmpProxys = { 5, "\53\6\1\6\2" };
AsnOid snmpModules = { 5, "\53\6\1\6\3" };
 * 
 */




AsnLen
PerEncObjectSyntaxV1(BUF_TYPE b, ObjectSyntax* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen = 0;
    AsnLen bitLen = 0;
    UAsnInt applByte;

    applByte = 8; /* 0000 1000 b needed for application choice */

    switch(v->choiceId)
    {
       case(OBJECTSYNTAX_INTEGER_VALUE):
    itemLen = PerEncSInt( b, (&v->a.integer_value));
    itemLen += PerEncLenDeter(b, &itemLen, 1);
    PerEncLenCons(b, 0, 5);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For integer_value this value is 0000 0000 b.
     */
     itemLen++;

     totalLen += itemLen;

    break;
       
       case(OBJECTSYNTAX_STRING_VALUE):
    itemLen = PerEncOcts( b, (v->a.string_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    /* FRAGMENTATION MAY BE THERE !!!!*/
    PerEncLenCons(b, 1, 5);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For string_value this value is 0010 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_OBJECTID_VALUE):
    itemLen = PerEncOid( b, (v->a.objectID_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, 2, 5);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For objectID_value this value is 0100 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;


       case(OBJECTSYNTAX_IPADDRESS_VALUE):
    itemLen = PerEncOcts( b, (v->a.ipAddress_value));
	/* 
	 * NO length field needed SIZE is always 4
	 */
    PerEncLenCons(b, (applByte | 0), 4);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For ipAddress_value this value is 1000 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_COUNTER_VALUE):
    itemLen = PerEncUInt( b, (&v->a.counter_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 1), 4);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For counter_value this value is 1001 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_GAUGE_VALUE):
    itemLen = PerEncUInt( b, (&v->a.gauge_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 2), 4);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For gauge_value this value is 1010 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_TIMETICKS_VALUE):
    itemLen = PerEncUInt( b, (&v->a.timeticks_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 3), 4);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For timeticks_value this value is 1011 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_ARBITRARY_VALUE):
    itemLen = PerEncOcts( b, (v->a.arbitrary_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    /* FRAGMENTATION !!!*/
    PerEncLenCons(b, (applByte | 4), 4);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For arbitrary_value this value is 1100 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* PerEncObjectSyntaxV1 */


	STATUS
PerDecObjectSyntaxV1(BUF_TYPE b,ObjectSyntax* v) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    UAsnInt applByte;
    UAsnInt elmtVal;
    UAsnInt simpleVal;
    UAsnInt applVal;

    applByte = 8; /* 0000 1000 b needed for application choice */

   
    PerPeekLenCons(b, &elmtVal, 7);
    
    switch(elmtVal)
    {
       case(0):

       PerDecLenCons(b, &simpleVal, 5);
       switch(simpleVal)
       {
	    case(0):
           (v->choiceId) = OBJECTSYNTAX_INTEGER_VALUE;
           PerDecLenDeter(b, &elmtLen, 1);
	   PerDecSInt(b, (&v->a.integer_value), elmtLen);
          break;
       	  
        case(1):
           (v->choiceId) = OBJECTSYNTAX_STRING_VALUE;
           PerDecLenDeter( b, &elmtLen, 1);
	   (v->a.string_value) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    	   PerDecOcts( b, (v->a.string_value), elmtLen);
    	  break;

        case(2):
           (v->choiceId) = OBJECTSYNTAX_OBJECTID_VALUE;
    	   PerDecLenDeter( b, &elmtLen, 1);
	   (v->a.objectID_value) = (AsnOid*) Asn1Alloc(sizeof(AsnOid));
    	   PerDecOid( b, (v->a.objectID_value), elmtLen);
    	  break;
          
	    default:
            Asn1Error("ERROR - unexpected PER simple syntax CHOICE\n");
          break;
       } /* end switch */
       break;
       
       case(1): /* application wide tagging in this case */
       
       PerPeekLenCons(b, &applVal, 4);
       applVal &= ~(applByte);
       
       switch(applVal)
       {
          case(0):
           (v->choiceId) = OBJECTSYNTAX_IPADDRESS_VALUE;
    	   (v->a.ipAddress_value) = (IpAddress*) Asn1Alloc(sizeof(IpAddress));
           PerDecLenCons(b, &applVal, 1);
    	   PerDecOcts( b, (v->a.ipAddress_value), 4);
    	   /* length is 4!!! always */
	  break;

          case(1):
           (v->choiceId) = OBJECTSYNTAX_COUNTER_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.counter_value), elmtLen);
    	  break;

       	  case(2):
           (v->choiceId) = OBJECTSYNTAX_GAUGE_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.gauge_value), elmtLen);
          break;

          case(3):
           (v->choiceId) = OBJECTSYNTAX_TIMETICKS_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.timeticks_value), elmtLen);
          break;

          case(4):
           (v->choiceId) = OBJECTSYNTAX_ARBITRARY_VALUE;
    	   (v->a.arbitrary_value) = (Opaque*) Asn1Alloc(sizeof(Opaque));
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
    	   PerDecOcts( b, (v->a.arbitrary_value), elmtLen);
          break;
       
          default:
            Asn1Error("ERROR - unexpected PER application CHOICE\n");
          break;
       } /*  end switch */
       break;
       
       default:
            Asn1Error("ERROR - unexpected PER simple & appl CHOICE\n");
       break;
    } /*  end switch */  
}   /*  PerDecObjectSyntaxV1 */





AsnLen
PerEncVarBindV1Choice(BUF_TYPE b, VarBindChoice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen = 0;

    switch(v->choiceId)
    {
       case(VARBINDCHOICE_VALUE):
    itemLen = PerEncObjectSyntaxV1( b, (v->a.value));

    totalLen += itemLen;

    break;

       case(VARBINDCHOICE_UNSPECIFIED):  
    PerEncLenCons( b, 3, 5);
    /*
     * The length field shows the CHOICE in Varbind
     * For unSpecified this value is 0110 0000 b.
     * because unSpecified is empty in SNMPV1 that means
	 * SimpleSyntax ----> value 3 as an index
     */
    itemLen++;

    totalLen += itemLen;

    break;
    }
    return (totalLen);

}  /* PerEncVarBindV1Choice */


STATUS
PerDecVarBindV1Choice(BUF_TYPE b, VarBindChoice* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    UAsnInt elmtVal = 0;

    PerPeekLenCons(b, &elmtVal, 5);
    if (elmtVal == 3)
    {
        (v->choiceId) = VARBINDCHOICE_UNSPECIFIED;
	    PerDecLenCons(b, &elmtVal, 5);
        /* elmtVal is 3 means that the emply case in simpleSyntax is
		   chosen. This value is mapped onto VARBINDCHOICE_UNSPECIFIED!!!*/
    }
    else
    {
    (v->a.value) = (ObjectSyntax*) Asn1Alloc(sizeof(ObjectSyntax));
    PerDecObjectSyntaxV1( b, (v->a.value));
    }
    return( OK );
} /*  PerDecVarBindChoice */




AsnLen
PerEncVarBindV1(BUF_TYPE b, VarBind* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;

    itemLen = PerEncVarBindV1Choice( b, (v->varBindChoice));

    totalLen += itemLen;

    itemLen = PerEncOid( b, (&v->name));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncVarBindV1 */


	STATUS
PerDecVarBindV1(BUF_TYPE b, VarBind* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;


    totalElmtsLen = PerDecLenDeter(b , &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecOid( b, (&v->name), elmtLen);


    (v->varBindChoice) = (VarBindChoice*) Asn1Alloc(sizeof(VarBindChoice));
    PerDecVarBindV1Choice( b, (v->varBindChoice));
}   /* PerDecVarBindV1 */



AsnLen
PerEncVarBindListV1(BUF_TYPE b, VarBindList* v, AsnLen *listLen)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    void* component;

        *listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    itemLen = PerEncVarBindV1( b, component);

	totalLen += itemLen;
        (*listLen)++;
    }
    return (totalLen);

}  /* PerEncVarBindListV1 */


	STATUS
PerDecVarBindListV1(BUF_TYPE b, VarBindList* v, AsnLen listLen) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;


    for ( totalElmtsLen = 0; (totalElmtsLen < listLen); totalElmtsLen++)
    {
        VarBind** tmpVar;
    
    tmpVar = (VarBind**) AsnListAppend(v);
    (*tmpVar) = (VarBind*) Asn1Alloc(sizeof(VarBind));
    PerDecVarBindV1(b, (*tmpVar));
    }  

    return( OK ); 
}   /* PerDecVarBindListV1 */



